#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from casa_stack_manip import stack_frame_find
from odict import odict
from types import * 
from task_statwt2 import statwt2
class statwt2_cli_:
    __name__ = "statwt2"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (statwt2_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'timebin':None, 'chanbin':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, vis=None, timebin=None, chanbin=None, ):

        """THIS APPLICATION IS CURRENTLY FOR TESTING ONLY! USE AT YOUR OWN RISK! Compute and set weights based on variance of data.
	Arguments :
		vis:	Name of measurement set
		   Default Value: 

		timebin:	Length for binning in time to determine statistics. Can either be integer to be multiplied by the representative integration time, a quantity (string) in time units
		   Default Value: 1

		chanbin:	Channel bin width for computing weights. Can either be integer, in which case it is interpreted as number of channels to include in each bin, or a string "spw" or quantity with frequency units.
		   Default Value: spw


	Example :

            THIS APPLICATION IS UNDER DEVELOPMENT AND CURRENTLY FOR TESTING ONLY! USE AT YOUR OWN RISK!

            THIS APPLICATION MODIFIES THE WEIGHT, WEIGHT SPECTRUM, FLAG, AND FLAG_ROW COLUMNS OF THE INPUT
            MS. IF YOU WANT A PRISTINE COPY OF THE INPUT MS TO BE PRESERVED, MAKE A COPY OF IT BEFORE
            RUNNING THIS APPLICATION.

            This application computes weights for the WEIGHT and WEIGHT_SPECTRUM (if present) columns
            based on the variance of values in the CORRECTED_DATA column. If the MS has no CORRECTED_DATA
            column, the application will fail.  The following algorithm is used:
 
            1. For unflagged data, create two sets of values, one set is composed solely of the real part
               of the data values, the other set is composed solely of the imaginary part of the data
               values.
            2. Compute the variance of each of these sets, vr and vi.
            3. Compute veq = (vr + vi)/2.
            4. The associated weight is just the reciprocal of veq. The weight will have unit
               of (data unit)^(-2), eg Jy^(-2).

            Data are aggregated on a per-baseline, per-data description ID basis. Data are aggregated
            in bins determined by the specified values of the timebin and chanbin parameters.
            
            TIME BINNING
            
            If the value of timebin is an integer, it means that the specified value should be
            multiplied by the representative integration time in the MS. This integration is the
            median value of all the values in the INTERVAL column. Flags are not considered in
            the integration time computation. If either extrema in the INTERVAL column differs from
            the median by more than 25%, the application will fail because the values vary too much
            for there to be a single, representative, integration time. The timebin parameter can
            also be specified as a quantity (string) that must have time conformant units.
            
            The time bins are not necessarily contiguous and are not necessarily the same width. The start
            of a bin is always coincident with a value from the TIME column, So for example, if values
            from the time column are [20, 60, 100, 140, 180, 230], and the width of the bins is chosen
            to be 110s, the first bin would start at 20s and run to 130s, so that data from timestamps
            20, 60, and 100 will be included in the first bin. The second bin would start at 140s, so that
            data for timestamps 140, 180, and 230 would be included in the second bin. Also, time binning
            does not span scan boundaries, so that data associated with different scan numbers will
            always be binned separately; changes in SCAN_NUMBER will cause a new time bin to be created,
            with its starting value coincident with the time of the new SCAN_NUMBER. Similar behavior can
            be expected for changes in FIELD_ID and ARRAY_ID.
            
            CHANNEL BINNING
            
            The width of channel bins is specified via the chanbin parameter. Channel binning occurs within
            individual spectral windows; bins never span multiple spectral windows. Each channel will
            be included in exactly one bin.
            
            The default value "spw" indicates that all channels in each spectral window are to be
            included in a single bin.
            
            Any other string value is interpreted as a quantity, and so should have frequency units, eg
            "1MHz". In this case, the channel frequencies from the CHAN_FREQ column of the SPECTRAL_WINDOW
            subtable of the MS are used to determine the bins. The first bin starts at the channel frequency
            of the 0th channel in the spectral window. Channels with frequencies that differ by less than
            the value specified by the chanbin parameter are included in this bin. The next bin starts at
            the frequency of the first channel outside the first bin, and the process is repeated until all
            channels have been binned.
            
            If specified as an integer, the value is interpreted as the number of channels to include in
            each bin. The final bin in the spectral window may not necessarily contain this number of
            channels. For example, if a spectral window has 15 channels, and chanbin is specified to be 6,
            then channels 0-5 will comprise the first bin, channels 6-11 the second, and channels 12-14 the
            third, so that only three channels will comprise the final bin.
            
            OTHER CONSIDERATIONS
            
            Flagged values are not used in computing the weights, although the associated weights of
            these values are updated.

            If the variance for a set of data is 0, all associated flags for that data are set to True,
            and the corresponding weights are set to 0.

        EXAMPLE 
        
        # update the weights of an MS using time binning of 300s
        statwt2("my.ms", timebin="300s")
    
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	casa = self.__globals__['casa']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'statwt2'
        self.__globals__['taskname'] = 'statwt2'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['vis'] = vis = self.parameters['vis']
            myparams['timebin'] = timebin = self.parameters['timebin']
            myparams['chanbin'] = chanbin = self.parameters['chanbin']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['timebin'] = timebin
        mytmp['chanbin'] = chanbin
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
	trec = casac.casac.utils().torecord(pathname+'statwt2.xml')

        casalog.origin('statwt2')
	try :
          #if not trec.has_key('statwt2') or not casac.casac.utils().verify(mytmp, trec['statwt2']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['statwt2'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('statwt2', 'statwt2.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'statwt2'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = statwt2(vis, timebin, chanbin)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'statwt2'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('statwt2', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['timebin']  = 1
        a['chanbin']  = 'spw'


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='statwt2', subkey=None):
        desc={'statwt2': 'THIS APPLICATION IS CURRENTLY FOR TESTING ONLY! USE AT YOUR OWN RISK! Compute and set weights based on variance of data.',
               'vis': 'Name of measurement set',
               'timebin': 'Length for binning in time to determine statistics. Can either be integer to be multiplied by the representative integration time, a quantity (string) in time units',
               'chanbin': 'Channel bin width for computing weights. Can either be integer, in which case it is interpreted as number of channels to include in each bin, or a string "spw" or quantity with frequency units.',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['timebin']  = 1
        a['chanbin']  = 'spw'

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if a.has_key(paramname) :
	      return a[paramname]
statwt2_cli = statwt2_cli_()
